
module StringList =
struct
  type t = string
  let compare x y = Pervasives.compare x y
end

module SL = SkipList.Make(StringList)

let show_off x =
  SL.add x "foo" "cat";
  SL.add x "test" "bar";
  SL.add x "bargle" "dog";
  SL.add x "aaard" "beagle";
  SL.add x "zeta" "omicron";
  SL.add x "testa" "bara";
  print_endline (SL.find x "zeta");
  print_endline (SL.find x "aaard");
  print_endline (SL.find x "testa");
  print_endline (SL.find x "foo");
  print_endline (SL.find x "bargle");
  print_endline (SL.find x "test");
  let f key data = Printf.printf "key: %s\tdata: %s\n" key data in
		SL.iter x f;
    print_endline "--------";
    flush stdout;
    SL.remove x "bargle";
    print_endline (SL.find x "foo");
    SL.iter x f;
    print_int (SL.fold x ~f:(fun k d arg -> max arg (String.length d)) ~init:0);
    print_newline ();
    SL.clear x;
    flush stdout;
    let _ = 
      try
        (* Should generate an exception *)
	      print_endline (SL.find x "foo")
      with
	        Not_found ->
		        print_endline "foo wasn't found! This is good." in
      x


let _ = 
  let _  = MtRand.self_init () in
  let sl = SL.create () in
    show_off sl
